#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/file.h>
#include	<utmp.h>
#include	<signal.h>

/* ----------------------------------------------------------------- */
/* This is a guard started by SERDEL together with a SMURPH or LANSF */
/* experiment.    Its objective is to detect an interactive user and */
/* checkpoint the simulator.                                         */
/* ----------------------------------------------------------------- */

#define	UTMP	"/etc/utmp"
#define	DEV	"/dev/"
#define	IDLE	(60*20)		/* Twenty minutes */
#define	SLEEP	10		/* Seconds */
#define	SIGCHKP	SIGUSR1
#define	BUFSIZE	32		/* Size of the utmp buffer */

int	spid,			/* Process id */
	utmp;

char	dname [80], *dnp;

main (argc, argv) int argc; char *argv []; {

    /* Get the argument; it tells the pid of the smurph/lansf process */
    if (argc < 2) exit (0);
    spid = atoi (argv [1]);

    if ((utmp = open (UTMP, O_RDONLY, 0)) < 0) exit (0);

    strcpy (dname, DEV);
    dnp = dname + strlen (dname);

    while (1) {
	if (dead ()) exit (0);
	if (active ()) {
		kill (spid, SIGCHKP);
	}
	sleep (SLEEP);
    }
}

int	dead () {

/* Checks is the experiment is still alive */

    return (kill (spid, 0) < 0);
}

int	active () {

/* Checks if there is an interactive user */

	char ubuf [sizeof (struct utmp) * BUFSIZE];
        struct utmp *bp;
	int  fill;
        struct stat dstat;
	time_t ctime, utime;

	lseek (utmp, (off_t) 0, L_SET);		/* Rewind the utmp file */
	ctime = time ((time_t*)0);

	while (1) {

	    if ((fill = read (utmp, ubuf, sizeof (struct utmp) * BUFSIZE)) <= 0)
		return (0);

	    fill /= sizeof (struct utmp);

	    for (bp = (struct utmp*) ubuf; fill; bp ++, fill --) {
		if (bp->ut_name [0] == '\0') continue;
		strcpy (dnp, bp->ut_line);
		if (stat (dname, &dstat) < 0) {
		    perror ("tryk");
		    continue;
		}
		utime = dstat.st_atime < dstat.st_mtime ? dstat.st_mtime :
		    dstat.st_atime;
		if (ctime - utime < IDLE) return (1);
	    }
	}
}
